(function() {
  var Baker, Build, Open, Task, Watch, color, exec, fs, path, spawn, _ref;
  var __hasProp = Object.prototype.hasOwnProperty, __indexOf = Array.prototype.indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (__hasProp.call(this, i) && this[i] === item) return i; } return -1; }, __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor; child.__super__ = parent.prototype; return child; };

  fs = require('fs');

  path = require('path');

  _ref = require('child_process'), exec = _ref.exec, spawn = _ref.spawn;

  color = function(string, code) {
    return "\x1b[" + (code + 30) + "m" + string + "\x1b[39m";
  };

  Task = (function() {

    function Task(directories) {
      if (!(directories instanceof Array)) {
        this.directories = [directories];
      } else {
        this.directories = directories;
      }
    }

    Task.prototype.resolve = function() {
      var callback, callbackCount, directory, extname, ignoreDir, ignoreFiles, marge, span, targetDir, targetFiles, uniq, _i, _j, _len, _len2, _results;
      marge = function(target, ignore) {
        var element, _i, _len, _results;
        target = uniq(target);
        ignore = uniq(ignore);
        _results = [];
        for (_i = 0, _len = target.length; _i < _len; _i++) {
          element = target[_i];
          if (__indexOf.call(ignore, element) < 0) _results.push(element);
        }
        return _results;
      };
      uniq = function(input) {
        var element, list, _i, _len;
        list = [];
        for (_i = 0, _len = input.length; _i < _len; _i++) {
          element = input[_i];
          if (__indexOf.call(list, element) < 0) list.push(element);
        }
        return list;
      };
      span = function(directory, extname, callback) {
        var name;
        name = "-name '*" + extname + "'";
        directory = "./" + (path.relative('./', directory));
        return exec("find " + directory + " -type f " + name + " -regex '\.\/[^\.].+[^~]$'", function(error, stdout) {
          if (error) throw error;
          return typeof callback === "function" ? callback(stdout.slice(0, -1).split('\n')) : void 0;
        });
      };
      if (arguments.length === 1) {
        callback = arguments[0];
        extname = '';
      } else {
        callback = arguments[1];
        extname = arguments[0];
      }
      targetFiles = [];
      ignoreFiles = [];
      callbackCount = this.directories.length;
      targetDir = (function() {
        var _i, _len, _ref2, _results;
        _ref2 = this.directories;
        _results = [];
        for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
          directory = _ref2[_i];
          if (directory[0] !== '!') _results.push(directory);
        }
        return _results;
      }).call(this);
      ignoreDir = (function() {
        var _i, _len, _ref2, _results;
        _ref2 = this.directories;
        _results = [];
        for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
          directory = _ref2[_i];
          if (directory[0] === '!') _results.push(directory);
        }
        return _results;
      }).call(this);
      for (_i = 0, _len = targetDir.length; _i < _len; _i++) {
        directory = targetDir[_i];
        span(directory, extname, function(spanned) {
          targetFiles = targetFiles.concat(spanned);
          callbackCount -= 1;
          if (callbackCount === 0) {
            return typeof callback === "function" ? callback(marge(targetFiles, ignoreFiles)) : void 0;
          }
        });
      }
      _results = [];
      for (_j = 0, _len2 = ignoreDir.length; _j < _len2; _j++) {
        directory = ignoreDir[_j];
        _results.push(span(directory.slice(1), extname, function(spanned) {
          ignoreFiles = ignoreFiles.concat(spanned);
          callbackCount -= 1;
          if (callbackCount === 0) {
            return typeof callback === "function" ? callback(marge(targetFiles, ignoreFiles)) : void 0;
          }
        }));
      }
      return _results;
    };

    return Task;

  })();

  Open = (function() {

    __extends(Open, Task);

    function Open(editor, directories) {
      this.editor = editor;
      this.directories = directories;
    }

    Open.prototype.open = function() {
      var _this = this;
      return this.resolve(function(paths) {
        return exec("" + _this.editor + " " + (paths.join(' ')), function(error, stdout) {
          var file, _i, _len, _results;
          if (error) throw error;
          _results = [];
          for (_i = 0, _len = paths.length; _i < _len; _i++) {
            file = paths[_i];
            _results.push(console.log("    " + (color('opened', 60)) + "\t" + file));
          }
          return _results;
        });
      });
    };

    Open.prototype.list = function() {
      var _this = this;
      return this.resolve(function(paths) {
        console.log('\n\t' + paths.join('\n\t'));
        return console.log('');
      });
    };

    return Open;

  })();

  Build = (function() {

    __extends(Build, Task);

    function Build(extname, directories, command) {
      this.extname = extname;
      this.directories = directories;
      this.command = command;
    }

    Build.prototype.build = function() {
      var _this = this;
      return this.resolve(this.extname, function(paths) {
        var file, _i, _len, _results;
        _results = [];
        for (_i = 0, _len = paths.length; _i < _len; _i++) {
          file = paths[_i];
          _results.push(_this.buildFile(file));
        }
        return _results;
      });
    };

    Build.prototype.buildFile = function(file) {
      var command, process;
      console.log("    " + (color('built ', 60)) + "\t" + file);
      command = (this.command(file)).split(' ');
      process = spawn(command[0], command.slice(1));
      process.stdout.on('data', function(data) {
        return console.log(data.toString());
      });
      return process.stderr.on('data', function(data) {
        return console.log(data.toString());
      });
    };

    Build.prototype.list = function() {
      var _this = this;
      return this.resolve(this.extname, function(paths) {
        var command;
        console.log;
        command = _this.command('#{ sourse }');
        console.log("\n    " + (color(command, 2)) + "\t" + (color(_this.extname, 60)));
        console.log("\t" + paths.join('\n\t'));
        return console.log("");
      });
    };

    return Build;

  })();

  Watch = (function() {

    __extends(Watch, Build);

    function Watch() {
      Watch.__super__.constructor.apply(this, arguments);
    }

    Watch.prototype.watch = function() {
      var _this = this;
      return this.resolve(this.extname, function(paths) {
        var file, _i, _len, _results;
        _results = [];
        for (_i = 0, _len = paths.length; _i < _len; _i++) {
          file = paths[_i];
          console.log("    " + (color('watching', 60)) + "\t" + file);
          _results.push(fs.watchFile(file, (function(file) {
            return function() {
              return _this.buildFile(file);
            };
          })(file)));
        }
        return _results;
      });
    };

    return Watch;

  })();

  Baker = (function() {

    function Baker() {}

    Baker.prototype.openTasks = [];

    Baker.prototype.buildTasks = [];

    Baker.prototype.watchTasks = [];

    Baker.prototype.open = function(editor, openPaths) {
      return this.openTasks.push(new Open(editor, openPaths));
    };

    Baker.prototype.listOpen = function(callback) {
      var task, _i, _len, _ref2, _results;
      if (this.openTasks.length !== 0) {
        _ref2 = this.openTasks;
        _results = [];
        for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
          task = _ref2[_i];
          _results.push(task.list());
        }
        return _results;
      } else {
        return console.log("\t" + (color('nothing to open', 3)));
      }
    };

    Baker.prototype.execOpen = function() {
      var task, _i, _len, _ref2, _results;
      _ref2 = this.openTasks;
      _results = [];
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        task = _ref2[_i];
        _results.push(task.open());
      }
      return _results;
    };

    Baker.prototype.build = function(extname, source, command) {
      return this.buildTasks.push(new Build(extname, source, command));
    };

    Baker.prototype.listBuild = function() {
      var task, _i, _len, _ref2, _results;
      if (this.buildTasks.length !== 0) {
        _ref2 = this.buildTasks;
        _results = [];
        for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
          task = _ref2[_i];
          _results.push(task.list());
        }
        return _results;
      } else {
        return console.log("\t" + (color('nothing to build', 3)));
      }
    };

    Baker.prototype.execBuild = function() {
      var task, _i, _len, _ref2, _results;
      _ref2 = this.buildTasks;
      _results = [];
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        task = _ref2[_i];
        _results.push(task.build());
      }
      return _results;
    };

    Baker.prototype.watch = function(extname, source, command) {
      this.buildTasks.push(new Build(extname, source, command));
      return this.watchTasks.push(new Watch(extname, source, command));
    };

    Baker.prototype.listWatch = function() {
      var task, _i, _len, _ref2, _results;
      if (this.watchTasks.length !== 0) {
        _ref2 = this.watchTasks;
        _results = [];
        for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
          task = _ref2[_i];
          _results.push(task.list());
        }
        return _results;
      } else {
        return console.log("\t" + (color('nothing to watch', 3)));
      }
    };

    Baker.prototype.execWatch = function() {
      var task, _i, _len, _ref2, _results;
      _ref2 = this.watchTasks;
      _results = [];
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        task = _ref2[_i];
        _results.push(task.watch());
      }
      return _results;
    };

    return Baker;

  })();

  module.exports = new Baker;

}).call(this);
