fs              = require 'fs'
path            = require 'path'
{exec, spawn}   = require 'child_process'

color = (string, code) ->
    "\x1b[#{ code + 30 }m#{ string }\x1b[39m"

class Task
    
    constructor: (directories) ->
        unless directories instanceof Array
            @directories = [directories]
        else
            @directories = directories
        
    resolve: ->
    
        marge = (target, ignore) ->
            target = uniq target        
            ignore = uniq ignore        
            # filter the ignore files out from the target list
            (element for element in target when element not in ignore)


        # produce a duplicate-free list
        uniq = (input) ->
            list = []
            for element in input
                if element not in list then list.push element
            return list

        # resolve a path into the containing files
        span = (directory, extname, callback) ->
            name = "-name '*#{ extname }'"
            directory = "./#{ path.relative './', directory }"    
            exec "find #{ directory } -type f #{ name } -regex '\.\/[^\.].+[^~]$'", (error, stdout) ->
                if error then throw error
                callback? stdout[..-2].split '\n'
    
        #   1 argument 
        #       callback
        #   2 argument
        #       extname, callback    
        if arguments.length is 1
            callback = arguments[0]
            extname = ''
        else
            callback = arguments[1]
            extname = arguments[0]
            
        targetFiles = []
        ignoreFiles = []
        callbackCount = @directories.length
        
        targetDir = (directory for directory in @directories when directory[0] isnt '!')
        ignoreDir = (directory for directory in @directories when directory[0] is '!')
        
        
        for directory in targetDir
            span directory, extname, (spanned) ->
                targetFiles = targetFiles.concat spanned
                callbackCount -= 1
                if callbackCount is 0
                    callback? marge targetFiles, ignoreFiles
                
        for directory in ignoreDir
            span directory[1..], extname, (spanned) ->
                ignoreFiles = ignoreFiles.concat spanned
                callbackCount -= 1
                if callbackCount is 0
                    callback? marge targetFiles, ignoreFiles
        
        
class Open extends Task
    constructor: (@editor, @directories) ->
    open: ->
        @resolve (paths) =>
            exec "#{ @editor } #{ paths.join ' ' }", (error, stdout) ->
                if error then throw error
                for file in paths
                    console.log "    #{ color 'opened', 60}\t#{ file }"
                
    list: ->
        @resolve (paths) =>
            console.log '\n\t' + paths.join '\n\t'
            console.log ''
        
class Build extends Task
    constructor: (@extname, @directories, @command) ->
    
    build: ->
        @resolve @extname, (paths) =>
            for file in paths
                @buildFile file
                    
    buildFile: (file) ->
        console.log "    #{ color 'built ', 60}\t#{ file }"
        command = (@command file).split ' '
        process = spawn command[0], command[1..]
        process.stdout.on 'data', (data) ->
            console.log data.toString()
        process.stderr.on 'data', (data) ->
            console.log data.toString()
        
        
            
    list: ->
        @resolve @extname, (paths) =>
            console.log
            command = @command '#{ sourse }'
            console.log "\n    #{ color command, 2 }\t#{ color @extname, 60 }"
            console.log "\t" + paths.join '\n\t'
            console.log ""
    
class Watch extends Build
    watch: ->
        @resolve @extname, (paths) =>
            for file in paths
                console.log "    #{ color 'watching', 60}\t#{ file }"
                fs.watchFile file, do (file) => =>
                    @buildFile file
                          
 


    
        
    
class Baker    
    
    openTasks: []
    buildTasks: []
    watchTasks: []
    
    
    open: (editor, openPaths) ->
        @openTasks.push new Open editor, openPaths    
    listOpen: (callback) -> 
        unless @openTasks.length is 0
            task.list() for task in @openTasks
        else
            console.log "\t#{ color 'nothing to open', 3}"
    execOpen: ->
        task.open() for task in @openTasks
        
    
    build: (extname, source, command) ->
        @buildTasks.push new Build extname, source, command    
    listBuild: ->
        unless @buildTasks.length is 0
            task.list() for task in @buildTasks
        else
            console.log "\t#{ color 'nothing to build', 3}"
            
    execBuild: ->
        task.build() for task in @buildTasks
        
        
    watch: (extname, source, command) ->
        @buildTasks.push new Build extname, source, command    
        @watchTasks.push new Watch extname, source, command    
    listWatch: ->
        unless @watchTasks.length is 0
            task.list() for task in @watchTasks
        else
            console.log "\t#{ color 'nothing to watch', 3}"
    execWatch: ->
        task.watch() for task in @watchTasks
    

                
module.exports = new Baker
